package gregapi.code;

import java.util.*;

/**
 * @author Gregorius Techneticies
 */
public class HashSetNoNulls<E> extends AbstractSet<E> {
	private transient HashMap<E, Object> map;
    private static final Object OBJECT = new Object();
    
    public HashSetNoNulls() {
        map = new HashMap<E, Object>();
    }
    
    public HashSetNoNulls(Collection<? extends E> c) {
        map = new HashMap<E, Object>(Math.max((int) (c.size()/.75f) + 1, 16));
        addAll(c);
    }
    
	public HashSetNoNulls(boolean aDummyParameter, E... aArray) {
		this(Arrays.asList(aArray));
	}
	
    public HashSetNoNulls(int initialCapacity, float loadFactor) {
        map = new HashMap<E, Object>(initialCapacity, loadFactor);
    }
    
    public HashSetNoNulls(int initialCapacity) {
        map = new HashMap<E, Object>(initialCapacity);
    }
    
    HashSetNoNulls(int initialCapacity, float loadFactor, boolean dummy) {
        map = new LinkedHashMap<E, Object>(initialCapacity, loadFactor);
    }
    
    @Override
	public Iterator<E> iterator() {
        return map.keySet().iterator();
    }
    
    @Override
	public int size() {
        return map.size();
    }
    
    @Override
	public boolean isEmpty() {
        return map.isEmpty();
    }
    
    @Override
	public boolean contains(Object o) {
        return map.containsKey(o);
    }
    
    @Override
	public boolean add(E e) {
        return e!=null&&map.put(e, OBJECT)==null;
    }
    
    @Override
	public boolean remove(Object o) {
        return map.remove(o)==OBJECT;
    }
    
    @Override
	public void clear() {
        map.clear();
    }
}