package gregapi.data;

import static gregapi.data.CS.*;
import gregapi.code.IItemContainer;
import gregapi.config.ConfigCategories;
import gregapi.data.CS.ConfigsGT;
import gregapi.data.CS.ItemsGT;
import gregapi.recipes.GT_ModHandler.ThermalExpansion;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.recipes.maps.*;
import gregapi.util.OM;
import gregapi.util.UT;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraftforge.fluids.FluidStack;

/**
 * @author Gregorius Techneticies
 * 
 * Class containing Recipe Maps, for Fuel Maps for into gregapi.data.FM
 */
@SuppressWarnings("deprecation")
public class RM {
	public static final RecipeMap
	  Furnace					= new RecipeMapFurnace				(null, "mc.recipe.furnace"						, "Furnace"							, "smelting"					, 0, 1, RES_PATH_GUI+"machines/E_Furnace"			,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F, T)
	, Microwave					= new RecipeMapMicrowave			(null, "gt.recipe.microwave"					, "Microwave"						, "smelting"					, 0, 1, RES_PATH_GUI+"machines/E_Furnace"			,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F, T)
	
	, ByProductList				= new RecipeMap						(null, "gt.recipe.byproductlist"				, "Ore Byproduct List"				, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 1, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, F, T)
	, CrucibleSmelting			= new RecipeMap						(null, "gt.recipe.cruciblesmelting"				, "Crucible Smelting"				, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 6, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, "Temperature: "		,    1, " K"	, T, T, F, T)
	, CrucibleAlloying			= new RecipeMap						(null, "gt.recipe.cruciblealloying"				, "Combination Smelting"			, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 6, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, "Temperature: "		,    1, " K"	, T, T, F, T)
	, Generifier				= new RecipeMap						(null, "gt.recipe.generifier"					, "Generifier"						, null, 0, 1, RES_PATH_GUI+"machines/Generifier"				,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 1, 1, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	
	, Boxinator					= new RecipeMap						(null, "gt.recipe.boxinator"					, "Boxinator"						, null, 0, 1, RES_PATH_GUI+"machines/Boxinator"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Unboxinator				= new RecipeMapUnboxinator			(null, "gt.recipe.unboxinator"					, "Unboxinator"						, null, 0, 1, RES_PATH_GUI+"machines/Unboxinator"				,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Sharpening				= new RecipeMap						(null, "gt.recipe.sharpener"					, "Sharpener"						, null, 0, 1, RES_PATH_GUI+"machines/Sharpener"					,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Sifting					= new RecipeMap						(null, "gt.recipe.sifter"						, "Sifter"							, null, 2, 1, RES_PATH_GUI+"machines/Sifter"					,/*IN-OUT-MIN-ITEM=*/ 1,12, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Hammer					= new RecipeMapHammer				(null, "gt.recipe.hammer"						, "Hammer"							, null, 6, 3, RES_PATH_GUI+"machines/Hammer"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, T, T)
	, Chisel					= new RecipeMapChisel				(null, "gt.recipe.chisel"						, "Chisel"							, null, 0, 1, RES_PATH_GUI+"machines/Chisel"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, T, T)
	, Shredder					= new RecipeMapShredder				(null, "gt.recipe.shredder"						, "Shredder"						, null, 0, 1, RES_PATH_GUI+"machines/Shredder"					,/*IN-OUT-MIN-ITEM=*/ 1, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Crusher					= new RecipeMapCrusher				(null, "gt.recipe.crusher"						, "Crusher"							, null, 0, 1, RES_PATH_GUI+"machines/Crusher"					,/*IN-OUT-MIN-ITEM=*/ 1, 4, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Lathe						= new RecipeMap						(null, "gt.recipe.lathe"						, "Lathe"							, null, 0, 1, RES_PATH_GUI+"machines/Lathe"						,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Cutter					= new RecipeMapCutter				(null, "gt.recipe.cutter"						, "Cutter"							, null, 0, 1, RES_PATH_GUI+"machines/Cutter"					,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 1, 0, 1,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Coagulator				= new RecipeMap						(null, "gt.recipe.coagulator"					, "Coagulator"						, null, 0, 1, RES_PATH_GUI+"machines/Coagulator"				,/*IN-OUT-MIN-ITEM=*/ 0, 1, 0,/*IN-OUT-MIN-FLUID=*/ 1, 0, 1,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Squeezer					= new RecipeMap						(null, "gt.recipe.squeezer"						, "Squeezer"						, null, 0, 1, RES_PATH_GUI+"machines/Squeezer"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 1, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Juicer					= new RecipeMap						(null, "gt.recipe.juicer"						, "Juicer"							, null, 0, 1, RES_PATH_GUI+"machines/Juicer"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 1, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Mortar					= new RecipeMap						(null, "gt.recipe.mortar"						, "Mortar"							, null, 0, 1, RES_PATH_GUI+"machines/Mortar"					,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Compressor				= new RecipeMap						(null, "gt.recipe.compressor"					, "Compressor"						, null, 0, 1, RES_PATH_GUI+"machines/Compressor"				,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Centrifuge				= new RecipeMap						(null, "gt.recipe.centrifuge"					, "Centrifuge"						, null, 0, 1, RES_PATH_GUI+"machines/Centrifuge"				,/*IN-OUT-MIN-ITEM=*/ 1, 6, 0,/*IN-OUT-MIN-FLUID=*/ 1, 6, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Electrolyzer				= new RecipeMap						(null, "gt.recipe.electrolyzer"					, "Electrolyzer"					, null, 0, 1, RES_PATH_GUI+"machines/Electrolyzer"				,/*IN-OUT-MIN-ITEM=*/ 1, 6, 0,/*IN-OUT-MIN-FLUID=*/ 1, 6, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, RollingMill				= new RecipeMap						(null, "gt.recipe.rollingmill"					, "Rolling Mill"					, null, 0, 1, RES_PATH_GUI+"machines/RollingMill"				,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, RollBender				= new RecipeMap						(null, "gt.recipe.rollbender"					, "Roll Bender"						, null, 0, 1, RES_PATH_GUI+"machines/RollBender"				,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, RollFormer				= new RecipeMap						(null, "gt.recipe.rollformer"					, "Roll Former"						, null, 0, 1, RES_PATH_GUI+"machines/RollFormer"				,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, ClusterMill				= new RecipeMap						(null, "gt.recipe.clustermill"					, "Cluster Mill"					, null, 0, 1, RES_PATH_GUI+"machines/ClusterMill"				,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Wiremill					= new RecipeMap						(null, "gt.recipe.wiremill"						, "Wiremill"						, null, 0, 1, RES_PATH_GUI+"machines/Wiremill"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Mixer						= new RecipeMap						(null, "gt.recipe.mixer"						, "Mixer"							, null, 0, 1, RES_PATH_GUI+"machines/Mixer"						,/*IN-OUT-MIN-ITEM=*/ 6, 1, 0,/*IN-OUT-MIN-FLUID=*/ 6, 2, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Canner					= new RecipeMapFluidCanner			(null, "gt.recipe.canner"						, "Canning Machine"					, null, 0, 1, RES_PATH_GUI+"machines/Canner"					,/*IN-OUT-MIN-ITEM=*/ 2, 2, 1,/*IN-OUT-MIN-FLUID=*/ 1, 1, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Injector					= new RecipeMap						(null, "gt.recipe.injector"						, "Injector"						, null, 0, 1, RES_PATH_GUI+"machines/Injector"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 0,/*IN-OUT-MIN-FLUID=*/ 2, 1, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Roasting					= new RecipeMap						(null, "gt.recipe.roaster"						, "Roaster"							, null, 0, 1, RES_PATH_GUI+"machines/Roaster"					,/*IN-OUT-MIN-ITEM=*/ 1, 3, 1,/*IN-OUT-MIN-FLUID=*/ 1, 1, 1,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Drying					= new RecipeMap						(null, "gt.recipe.drying"						, "Dryer"							, null, 0, 1, RES_PATH_GUI+"machines/Dryer"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 1, 1, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Fermenter					= new RecipeMap						(null, "gt.recipe.fermenter"					, "Fermenter"						, null, 0, 1, RES_PATH_GUI+"machines/Fermenter"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 1, 1, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Distillery				= new RecipeMap						(null, "gt.recipe.distillery"					, "Distillery"						, null, 0, 1, RES_PATH_GUI+"machines/Distillery"				,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 1, 2, 1,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Extruder					= new RecipeMap						(null, "gt.recipe.extruder"						, "Extruder"						, null, 0, 1, RES_PATH_GUI+"machines/Extruder"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Polarizer					= new RecipeMap						(null, "gt.recipe.polarizer"					, "Polarizer"						, null, 0, 1, RES_PATH_GUI+"machines/Polarizer"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Loom						= new RecipeMap						(null, "gt.recipe.loom"							, "Loom"							, null, 0, 1, RES_PATH_GUI+"machines/Loom"						,/*IN-OUT-MIN-ITEM=*/ 6, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Cooking					= new RecipeMap						(null, "gt.recipe.cooker"						, "Cooker"							, null, 0, 1, RES_PATH_GUI+"machines/Cooker"					,/*IN-OUT-MIN-ITEM=*/ 9, 1, 1,/*IN-OUT-MIN-FLUID=*/ 3, 1, 1,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Press						= new RecipeMapFormingPress			(null, "gt.recipe.press"						, "Press"							, null, 0, 1, RES_PATH_GUI+"machines/Press"						,/*IN-OUT-MIN-ITEM=*/ 3, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Bath						= new RecipeMapBath					(null, "gt.recipe.bath"							, "Bath"							, null, 0, 1, RES_PATH_GUI+"machines/Bath"						,/*IN-OUT-MIN-ITEM=*/ 6, 6, 1,/*IN-OUT-MIN-FLUID=*/ 1, 3, 1,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Smelter					= new RecipeMap						(null, "gt.recipe.smelter"						, "Smelter"							, null, 0, 1, RES_PATH_GUI+"machines/Smelter"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 1, 1, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, LaserEngraver				= new RecipeMap						(null, "gt.recipe.laserengraver"				, "Precision Laser Engraver"		, null, 0, 1, RES_PATH_GUI+"machines/LaserEngraver"				,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Welder					= new RecipeMap						(null, "gt.recipe.welder"						, "Welding Machine"					, null, 0, 1, RES_PATH_GUI+"machines/Welder"					,/*IN-OUT-MIN-ITEM=*/ 6, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, CrystallisationCrucible	= new RecipeMap						(null, "gt.recipe.crystallisationcrucible"		, "Crystallisation Crucible"		, null, 0, 1, RES_PATH_GUI+"machines/CrystallisationCrucible"	,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 2, 0, 1,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, ScannerVisuals			= new RecipeMapScannerVisuals		(null, "gt.recipe.scannervisuals"				, "Scanner (Visuals)"				, null, 0, 1, RES_PATH_GUI+"machines/ScannerVisuals"			,/*IN-OUT-MIN-ITEM=*/ 2, 2, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Printer					= new RecipeMapPrinter				(null, "gt.recipe.printer"						, "Printer"							, null, 0, 1, RES_PATH_GUI+"machines/Printer"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 1,/*IN-OUT-MIN-FLUID=*/ 6, 0, 1,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Sluice					= new RecipeMap						(null, "gt.recipe.sluice"						, "Sluice"							, null, 0, 1, RES_PATH_GUI+"machines/Sluice"					,/*IN-OUT-MIN-ITEM=*/ 1, 9, 1,/*IN-OUT-MIN-FLUID=*/ 1, 1, 1,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, MagneticSeparator			= new RecipeMap						(null, "gt.recipe.magneticseparator"			, "Magnetic Separator"				, null, 0, 1, RES_PATH_GUI+"machines/MagneticSeparator"			,/*IN-OUT-MIN-ITEM=*/ 1, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Autocrafter				= new RecipeMapAutocrafting			(null, "gt.recipe.autocrafting"					, "Crafting"						, null, 0, 1, RES_PATH_GUI+"machines/Crafting"					,/*IN-OUT-MIN-ITEM=*/ 9,12, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, F, F, T)
	, Massfab					= new RecipeMap						(null, "gt.recipe.massfab"						, "Matter Fabricator"				, null, 0, 1, RES_PATH_GUI+"machines/Massfab"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 1, 2, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, ScannerMolecular			= new RecipeMapScannerMolecular		(null, "gt.recipe.scannermolecular"				, "Molecular Scanner"				, null, 0, 1, RES_PATH_GUI+"machines/ScannerMolecular"			,/*IN-OUT-MIN-ITEM=*/ 2, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Replicator				= new RecipeMapReplicator			(null, "gt.recipe.replicator"					, "Matter Replicator"				, null, 0, 1, RES_PATH_GUI+"machines/Replicator"				,/*IN-OUT-MIN-ITEM=*/ 3, 3, 1,/*IN-OUT-MIN-FLUID=*/ 3, 3, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Slicer					= new RecipeMap						(null, "gt.recipe.slicer"						, "Slicer"							, null, 0, 1, RES_PATH_GUI+"machines/Slicer"					,/*IN-OUT-MIN-ITEM=*/ 2, 2, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, Laminator					= new RecipeMap						(null, "gt.recipe.laminator"					, "Laminator"						, null, 0, 1, RES_PATH_GUI+"machines/Laminator"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 2,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, CokeOven					= new RecipeMap						(null, "gt.recipe.cokeoven"						, "Coke Oven"						, null, 0, 1, RES_PATH_GUI+"machines/CokeOven"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 1, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	, DistillationTower			= new RecipeMap						(null, "gt.recipe.distillationtower"			, "Distillation Tower"				, null, 0, 1, RES_PATH_GUI+"machines/DistillationTower"			,/*IN-OUT-MIN-ITEM=*/ 1, 3, 0,/*IN-OUT-MIN-FLUID=*/ 1, 9, 0,/*MIN*/ 1,/*AMP=*/ 1, ""					,    1, ""		, T, T, T, T)
	
	, Autoclave					= new RecipeMap						(null, "gt.recipe.autoclave"					, "Autoclave"						, null, 0, 1, RES_PATH_GUI+"machines/Autoclave"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/, T)
	, Fusion					= new RecipeMap						(null, "gt.recipe.fusionreactor"				, "Fusion Reactor"					, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, "Start: "				,    1, " EU"	, T, F/*F*/, F/*T*/, T)
	, BlastFurnace				= new RecipeMap						(null, "gt.recipe.blastfurnace"					, "Blast Furnace"					, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 2, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, "Heat Capacity: "		,    1, " K"	, F, F/*T*/, F/*T*/, T)
	, ImplosionCompressor		= new RecipeMap						(null, "gt.recipe.implosioncompressor"			, "Implosion Compressor"			, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 2, 2, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/, T)
	, VacuumFreezer				= new RecipeMap						(null, "gt.recipe.vacuumfreezer"				, "Vacuum Freezer"					, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/, T)
	, Assembler					= new RecipeMapAssembler			(null, "gt.recipe.assembler"					, "Assembler"						, null, 0, 1, RES_PATH_GUI+"machines/Assembler"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 1,/*IN-OUT-MIN-FLUID=*/ 1, 0, 0,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/, T)
	, CNC						= new RecipeMap						(null, "gt.recipe.cncmachine"					, "CNC Machine"						, null, 0, 1, RES_PATH_GUI+"machines/Default"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 1, 0, 1,/*MIN*/ 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/, T)
	;
	
	// For Compatibility with old API Stuff.
	static {RecipeMap.sFurnaceRecipes = RM.Furnace;RecipeMap.sMicrowaveRecipes = RM.Microwave;RecipeMap.sFurnaceFuel = FM.Furnace;RecipeMap.sByProductList = RM.ByProductList;RecipeMap.sCrucibleSmelting = RM.CrucibleSmelting;RecipeMap.sCrucibleAlloying = RM.CrucibleAlloying;RecipeMap.sGenerifierRecipes = RM.Generifier;RecipeMap.sSharpeningRecipes = RM.Sharpening;RecipeMap.sSifterRecipes = RM.Sifting;RecipeMap.sHammerRecipes = RM.Hammer;RecipeMap.sChiselRecipes = RM.Chisel;RecipeMap.sShredderRecipes = RM.Shredder;RecipeMap.sCrusherRecipes = RM.Crusher;RecipeMap.sLatheRecipes = RM.Lathe;RecipeMap.sCutterRecipes = RM.Cutter;RecipeMap.sCoagulatorRecipes = RM.Coagulator;RecipeMap.sSqueezerRecipes = RM.Squeezer;RecipeMap.sJuicerRecipes = RM.Juicer;RecipeMap.sMortarRecipes = RM.Mortar;RecipeMap.sCompressorRecipes = RM.Compressor;RecipeMap.sCentrifugeRecipes = RM.Centrifuge;RecipeMap.sElectrolyzerRecipes = RM.Electrolyzer;RecipeMap.sRollingMillRecipes = RM.RollingMill;RecipeMap.sRollBenderRecipes = RM.RollBender;RecipeMap.sRollFormerRecipes = RM.RollFormer;RecipeMap.sClusterMillRecipes = RM.ClusterMill;RecipeMap.sWiremillRecipes = RM.Wiremill;RecipeMap.sMixerRecipes = RM.Mixer;RecipeMap.sCannerRecipes = RM.Canner;RecipeMap.sInjectorRecipes = RM.Injector;RecipeMap.sRoastingRecipes = RM.Roasting;RecipeMap.sDryingRecipes = RM.Drying;RecipeMap.sFermenterRecipes = RM.Fermenter;RecipeMap.sDistilleryRecipes = RM.Distillery;RecipeMap.sExtruderRecipes = RM.Extruder;RecipeMap.sPolarizerRecipes = RM.Polarizer;RecipeMap.sLoomRecipes = RM.Loom;RecipeMap.sCookingRecipes = RM.Cooking;RecipeMap.sPressRecipes = RM.Press;RecipeMap.sBathRecipes = RM.Bath;RecipeMap.sSmelterRecipes = RM.Smelter;RecipeMap.sLaserEngraverRecipes = RM.LaserEngraver;RecipeMap.sWelderRecipes = RM.Welder;RecipeMap.sCrystallisationCrucibleRecipes = RM.CrystallisationCrucible;RecipeMap.sScannerVisualsRecipes = RM.ScannerVisuals;RecipeMap.sPrinterRecipes = RM.Printer;RecipeMap.sSluiceRecipes = RM.Sluice;RecipeMap.sMagneticSeparatorRecipes = RM.MagneticSeparator;RecipeMap.sAutocrafterRecipes = RM.Autocrafter;RecipeMap.sMassfabRecipes = RM.Massfab;RecipeMap.sScannerMolecularRecipes = RM.ScannerMolecular;RecipeMap.sReplicatorRecipes = RM.Replicator;RecipeMap.sSlicerRecipes = RM.Slicer;RecipeMap.sCokeOvenRecipes = RM.CokeOven;RecipeMap.sDistillationTowerRecipes = RM.DistillationTower;RecipeMap.sAutoclaveRecipes = RM.Autoclave;RecipeMap.sBoxinatorRecipes = RM.Boxinator;RecipeMap.sUnboxinatorRecipes = RM.Unboxinator;RecipeMap.sFusionRecipes = RM.Fusion;RecipeMap.sBlastRecipes = RM.BlastFurnace;RecipeMap.sImplosionRecipes = RM.ImplosionCompressor;RecipeMap.sVacuumRecipes = RM.VacuumFreezer;RecipeMap.sAssemblerRecipes = RM.Assembler;RecipeMap.sCNCRecipes = RM.CNC;RecipeMap.sFuelsBurn = FM.Burn;RecipeMap.sFuelsGas = FM.Gas;RecipeMap.sFuelsHot = FM.Hot;RecipeMap.sFuelsPlasma = FM.Plasma;RecipeMap.sFuelsEngine = FM.Engine;RecipeMap.sFuelsTurbine = FM.Turbine;RecipeMap.sFuelsMagic = FM.Magic;}
	
	
	
	
	
	public static boolean sawing(long aEUt, long aDuration, boolean aIsFoodItem, long aLubricantAmount, ItemStack aInput, ItemStack... aOutputs) {
		if (UT.Stacks.invalid(aInput) || aOutputs.length <= 0 || UT.Stacks.invalid(aOutputs[0])) return F;
		if (aLubricantAmount <= 0) aLubricantAmount = 1;
		
        FluidStack[] tFluids = new FluidStack[] {UT.Fluids.water(4000), UT.Fluids.distilledwater(4000), MT.Lubricant.liquid(U, T), UT.Fluids.make("rc lubricant", 1000)};
        long[] tTime = new long[] {4, 3, 1, 1};
        
        for (byte i = 0; i < tFluids.length; i++) if (tFluids[i] != null && (!aIsFoodItem || i <= 2)) RM.Cutter.addRecipe1(T, aEUt, aDuration*tTime[i], aInput, UT.Fluids.mul(tFluids[i], aLubricantAmount, 1000, T), NF, aOutputs);
        
		return F;
	}
	
	public static boolean food_can(ItemStack aStack, int aFoodValue, String aCannedName, IItemContainer... aCans) {
		if (UT.Stacks.invalid(aStack) || aStack.getItem() == ItemsGT.sMultiItemCans || IL.IC2_Food_Can_Filled.equal(aStack, T, T)) return F;
		if (aFoodValue > 0) switch(aFoodValue / 2) {
	    case  0: case  1:										return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[0].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
    	case  2:												return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[1].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  3:												return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[2].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  4:												return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[3].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  5:												return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[4].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  8: case  9:										return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(2), aCans[3].getWithName(2, aCannedName), UT.Stacks.container(aStack, T));
        case 10: case 11:										return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(2), aCans[4].getWithName(2, aCannedName), UT.Stacks.container(aStack, T));
        case 15: case 16: case 17:								return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(3), aCans[4].getWithName(3, aCannedName), UT.Stacks.container(aStack, T));
        case 20: case 21: case 22: case 23:						return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(4), aCans[4].getWithName(4, aCannedName), UT.Stacks.container(aStack, T));
        case 25: case 26: case 27: case 28: case 29:			return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(5), aCans[4].getWithName(5, aCannedName), UT.Stacks.container(aStack, T));
        default:												return null != RM.Canner.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(aFoodValue/12), aCans[5].getWithName(aFoodValue/12, aCannedName), UT.Stacks.container(aStack, T));
	    }
		return F;
	}
	
    public static ItemStack get_smelting(ItemStack aInput, boolean aRemoveInput, ItemStack aOutputSlot) {
    	if (aInput == null || aInput.stackSize < 1) return NI;
    	ItemStack rStack = OM.get(FurnaceRecipes.smelting().getSmeltingResult(aInput));
    	if (rStack != null && (aOutputSlot == null || (UT.Stacks.equal(rStack, aOutputSlot) && rStack.stackSize + aOutputSlot.stackSize <= aOutputSlot.getMaxStackSize()))) {
			if (aRemoveInput) aInput.stackSize--;
			return rStack;
		}
    	return NI;
    }
	public static boolean add_smelting(ItemStack aInput, ItemStack aOutput) {
		return add_smelting(aInput, aOutput, 0);
	}
	public static boolean add_smelting(ItemStack aInput, ItemStack aOutput, float aEXP) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput)) return F;
		aOutput = OM.get_(aOutput);
		if (UT.Stacks.container(aInput, F) != null || UT.Stacks.equal_(aInput, aOutput, F) || !ConfigsGT.RECIPES.get(ConfigCategories.Machines.smelting, aInput, T)) return F;
		FurnaceRecipes.smelting().func_151394_a(aInput, UT.Stacks.copy(aOutput), aEXP);
		return T;
	}
	public static boolean rem_smelting(ItemStack aInput) {
		if (UT.Stacks.valid(aInput)) for (Object tInput : FurnaceRecipes.smelting().getSmeltingList().keySet()) if (UT.Stacks.valid(tInput) && UT.Stacks.equal_(aInput, (ItemStack)tInput, T)) {FurnaceRecipes.smelting().getSmeltingList().remove(tInput); return T;}
		return F;
	}
	
	public static boolean pulverizing(ItemStack aInput, ItemStack aOutput1) {return pulverizing(aInput, aOutput1, null, 0, F);}
	public static boolean pulverizing(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2) {return pulverizing(aInput, aOutput1, aOutput2, 100, F);}
	public static boolean pulverizing(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, int aChance) {return pulverizing(aInput, aOutput1, aOutput2, aChance, F);}
	public static boolean pulverizing(ItemStack aInput, ItemStack aOutput1, boolean aOverwrite) {return pulverizing(aInput, aOutput1, null, 0, aOverwrite);}
	public static boolean pulverizing(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, boolean aOverwrite) {return pulverizing(aInput, aOutput1, aOutput2, 100, aOverwrite);}
	public static boolean pulverizing(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, int aChance, boolean aOverwrite) {return pulverizing(aInput, aOutput1, aOutput2, aChance, null, 0, aOverwrite);}
	public static boolean pulverizing(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, int aChance2, ItemStack aOutput3, int aChance3, boolean aOverwrite) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput1)) return F;
		aOutput1 = OM.get_(aOutput1);
		aOutput2 = OM.get(aOutput2);
		
		if (UT.Stacks.container(aInput, F) == null) {
			if (ENABLE_ADDING_IC2_MACERATOR_RECIPES) {
				if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.maceration, aInput, T)) {
					UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.macerator, aInput, null, aOutput1);
				} else {
					UT.removeSimpleIC2MachineRecipe(aInput, ic2.api.recipe.Recipes.macerator.getRecipes(), null);
				}
			}
			
			if (!OP.log.contains(aInput)) {
				if (MT.TECH.AnyWood.contains(aOutput1)) {
					if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.pulverization, aInput, T)) {
						if (aOutput2 == null)
							ThermalExpansion.addSawmillRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1));
						else
							ThermalExpansion.addSawmillRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1), UT.Stacks.copy(aOutput2), aChance2<=0?10:aChance2);
					}
				} else {
					if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.rockcrushing, aInput, UT.Stacks.block(aInput) != NB)) {
						try {
							if (UT.Stacks.block(aInput) != Blocks.obsidian && UT.Stacks.block(aInput) != Blocks.gravel) {
								mods.railcraft.api.crafting.IRockCrusherRecipe tRecipe = mods.railcraft.api.crafting.RailcraftCraftingManager.rockCrusher.createNewRecipe(UT.Stacks.amount(1, aInput), UT.Stacks.meta(aInput) != W, F);
								tRecipe.addOutput(UT.Stacks.copy(aOutput1), 1.0F/aInput.stackSize);
								if (aOutput2 != null) tRecipe.addOutput(UT.Stacks.copy(aOutput2), (0.01F*(aChance2<=0?10:aChance2))/aInput.stackSize);
								if (aOutput3 != null) tRecipe.addOutput(UT.Stacks.copy(aOutput3), (0.01F*(aChance3<=0?10:aChance3))/aInput.stackSize);
							}
						} catch(Throwable e) {/*Do nothing*/}
					}
					if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.pulverization, aInput, T)) {
						if (aOutput2 == null)
							ThermalExpansion.addPulverizerRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1));
						else
							ThermalExpansion.addPulverizerRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1), UT.Stacks.copy(aOutput2), aChance2<=0?10:aChance2);
					}
				}
			}
		}
		return T;
	}
	public static boolean ic2_extractor(ItemStack aInput, ItemStack aOutput) {
		if (!ENABLE_ADDING_IC2_EXTRACTOR_RECIPES || UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput)) return F;
		aOutput = OM.get_(aOutput);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.extractor, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, ic2.api.recipe.Recipes.extractor.getRecipes(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.extractor, aInput, null, aOutput);
		return T;
	}
	public static boolean ic2_compressor(ItemStack aInput, ItemStack aOutput) {
		if (!ENABLE_ADDING_IC2_COMPRESSOR_RECIPES || UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput)) return F;
		aOutput = OM.get_(aOutput);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.compression, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, ic2.api.recipe.Recipes.compressor.getRecipes(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.compressor, aInput, null, aOutput);
		return T;
	}
	public static boolean ic2_orewasher(ItemStack aInput, long aWaterAmount, Object... aOutput) {
		if (!ENABLE_ADDING_IC2_OREWASHER_RECIPES || UT.Stacks.invalid(aInput) || aOutput == null || aOutput.length <= 0 || aOutput[0] == null) return F;
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.orewashing, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, ic2.api.recipe.Recipes.oreWashing.getRecipes(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.oreWashing, aInput, UT.NBT.getNBTLong(null, "amount", aWaterAmount), aOutput);
		return T;
	}
	public static boolean ic2_centrifuge(ItemStack aInput, long aHeat, Object... aOutput) {
		if (!ENABLE_ADDING_IC2_CENTRIFUGE_RECIPES || UT.Stacks.invalid(aInput) || aOutput == null || aOutput.length <= 0 || aOutput[0] == null) return F;
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.thermalcentrifuge, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, ic2.api.recipe.Recipes.centrifuge.getRecipes(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.centrifuge, aInput, UT.NBT.getNBTLong(null, "minHeat", aHeat), aOutput);
		return T;
	}
}